/*----------------------------------------------------------------------
  Copyright (C) 1997, IGS Technology, Inc.

  Permission is hereby granted to use, copy and modify this software
  only for the purpose of developing IGS Technology related products.

  This software may not be distributed to any party which is not covered
  by IGS Technology Non-Disclosure Agreement (NDA).

  This software is provided "as is" without warranty of any kind,
  either expressed or implied, including but not limited to the implied
  warranties of merchantability and/or fitness for a particular purpose.

  Author: Bo
  ----------------------------------------------------------------------*/
#ifndef _IGSCOP_H
#define _IGSCOP_H

#define  MaskMap								0x00
#define  PxMapA 								0x01
#define  PxMapB 								0x02
#define  PxMapC 								0x03
#define  Px_INTEL_ORDER				 	0x00
#define  Px_MOTOR_ORDER				 	0x08
#define  Px_Size_1							0x00
#define  Px_Size_2							0x01
#define  Px_Size_4							0x02
#define  Px_Size_8							0x03

#define  Mix_Zero								0x00
#define  Mix_S_And_D						0x01
#define  Mix_S_And_ND						0x02
#define  Mix_S									0x03
#define  Mix_NS_And_D						0x04
#define  Mix_D									0x05
#define  Mix_S_Xor_D						0x06
#define  Mix_S_Or_D							0x07
#define  Mix_NS_And_ND					0x08
#define  Mix_S_Xor_ND						0x09
#define  Mix_ND 								0x0A
#define  Mix_S_Or_ND						0x0B
#define  Mix_NS 								0x0C
#define  Mix_NS_Or_D						0x0D
#define  Mix_NS_Or_ND						0x0E
#define  Mix_Ones								0x0F

/*PxOp register*/
#define  Mask_Map_Disabled			0x00000000
#define  Mask_Map_Bound_Enabled 0x00000040
#define  Mask_Map_Enabled				0x00000080
#define  All_Pixel							0x00000000
#define  Mask_Area_Bound				0x00000030
#define  Right_Down							0x00000000
#define  Left_Up								0x00000007
#define  Src_PxMap_A						0x00100000
#define  Dest_PxMap_A						0x00010000
#define  Pattern_PxMap_A				0x00001000
#define  Pattern_PxMap_B				0x00002000
#define  Pattern_PxMap_C				0x00003000
#define  Pattern_Foreground			0x00008000
#define  Pattern_From_Src				0x00009000
#define  Src_PxMap_B						0x00200000
#define  Dest_PxMap_B						0x00020000
#define  Src_PxMap_C						0x00300000
#define  Dest_PxMap_C						0x00030000
#define  Fore_Src_color 				0x00000000
#define  Back_Src_color 				0x00000000
#define  Fore_Src_PxMap 				0x20000000
#define  Back_Src_PxMap 				0x80000000
#define  PxBlt									0x08000000
#define  PxBlt_Invert						0x09000000
#define  PxBlt_Area_Fill				0x0A000000
#define  Step_Draw_Read 				0x02000000
#define  Line_Draw_Read 				0x03000000
#define  Step_Draw_Write				0x04000000
#define  Line_Draw_Write				0x05000000

#define  TextOut_Opq						0x00001000
#define  PattTil_Opq						0x00002000
#define  StyleLine_Opq					0x00003000
#define  TextOut_Tra						0x00005000
#define  PattTil_Tra						0x00006000
#define  StyleLine_Tra					0x00007000
#define  SrcTil_Opq							0x00009000
#define  HostBltWrite						0x00020000
#define  HostBltRead						0x00010000

#define  PosDX									0x00000000
#define  NegDX									0x00000004
#define  PosDY									0x00000000
#define  NegDY									0x00000002
#define  PosDZ									0x00000000
#define  NegDZ									0x00000001

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   IGS graphics engine registers
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
// orig: #define XGAAddr 0xBF000000
#ifdef arm
#define XGAAddr 								0xd08bf000L
#elif defined(x86)
#define XGAAddr 								0xbf000L
#else
#error ERROR! Please define the HOSTTYPE environemnt variable to arm or x86.
#endif

unsigned long *	Page_Base          = (unsigned long*)(XGAAddr+0x0000);
unsigned long *	Virtual_Addr       = (unsigned long*)(XGAAddr+0x0004);
unsigned short*	Reserved08         = (unsigned short*)(XGAAddr+0x000E);
unsigned char *	State_A_Len        = (unsigned char*)(XGAAddr+0x000C);
unsigned char *	State_B_Len        = (unsigned char*)(XGAAddr+0x000D);
unsigned short*	Reserved0E         = (unsigned short*)(XGAAddr+0x000E);
unsigned short*	Reserved10         = (unsigned short*)(XGAAddr+0x0010);
unsigned char *	Cop_control        = (unsigned char*)(XGAAddr+0x0011);
unsigned char *	Px_Map_Index       = (unsigned char*)(XGAAddr+0x0012);
unsigned short*	Reserved13	       = (unsigned short*)(XGAAddr+0x0013);
unsigned long *	Px_Map_Base	       = (unsigned long*)(XGAAddr+0x0014);
unsigned short*	Src_Map_Width      = (unsigned short*)(XGAAddr+0x0018);
unsigned short*	Src2_Map_Width     = (unsigned short*)(XGAAddr+0x0118);
unsigned short*	Dst_Map_Width      = (unsigned short*)(XGAAddr+0x0218);
unsigned short*	Px_Map_Height      = (unsigned short*)(XGAAddr+0x001A);
unsigned char *	Px_Map_Format      = (unsigned char*)(XGAAddr+0x001C);
unsigned short*	Reserved1D	       = (unsigned short*)(XGAAddr+0x001D);
unsigned short*	Reserved1E	       = (unsigned short*)(XGAAddr+0x001E);
unsigned short*	Reserved1F	       = (unsigned short*)(XGAAddr+0x001F);
unsigned short*	Bres_Err_Term      = (unsigned short*)(XGAAddr+0x0020);
unsigned short*	Reserved22	       = (unsigned short*)(XGAAddr+0x0022);
unsigned short*	Bres_K1	           = (unsigned short*)(XGAAddr+0x0024);
unsigned short*	Reserved26	       = (unsigned short*)(XGAAddr+0x0026);
unsigned short*	Bres_K2	           = (unsigned short*)(XGAAddr+0x0028);
unsigned short*	Reserved2A	       = (unsigned short*)(XGAAddr+0x002A);

unsigned long *	Direction_Step     = (unsigned long*)(XGAAddr+0x002C);
unsigned short*	Direction_StepL    = (unsigned short*)(XGAAddr+0x002C);
unsigned short*	Direction_StepH    = (unsigned short*)(XGAAddr+0x002C+0x2);

unsigned short*	Reserved30	       = (unsigned short*)(XGAAddr+0x0030);
unsigned short*	Reserved34	       = (unsigned short*)(XGAAddr+0x0034);
unsigned short*	Reserved38	       = (unsigned short*)(XGAAddr+0x0038);
unsigned short*	Reserved3C	       = (unsigned short*)(XGAAddr+0x003C);
unsigned short*	Reserved40	       = (unsigned short*)(XGAAddr+0x0040);
unsigned short*	Reserved44	       = (unsigned short*)(XGAAddr+0x0044);
unsigned char *	Fore_Mix	         = (unsigned char*)(XGAAddr+0x0048);
unsigned char *	Back_Mix	         = (unsigned char*)(XGAAddr+0x0049);
unsigned char *	Dest_Color_Comp    = (unsigned char*)(XGAAddr+0x004A);
unsigned short*	Reserved4B	       = (unsigned short*)(XGAAddr+0x004B);
unsigned long *	Color_Comp_Val     = (unsigned long*)(XGAAddr+0x004C);
unsigned long *	Px_Bit_Mask	       = (unsigned long*)(XGAAddr+0x0050);
unsigned long *	Carry_Chain_Mask   = (unsigned long*)(XGAAddr+0x0054);
unsigned long *	Fore_Color	       = (unsigned long*)(XGAAddr+0x0058);
unsigned long *	Back_Color	       = (unsigned long*)(XGAAddr+0x005C);
unsigned short*	Op_Dimension_1     = (unsigned short*)(XGAAddr+0x0060);
unsigned short*	Op_Dimension_2     = (unsigned short*)(XGAAddr+0x0062);
unsigned short*	Reserved64	       = (unsigned short*)(XGAAddr+0x0064);
unsigned short*	Reserved68	       = (unsigned short*)(XGAAddr+0x0068);
unsigned short*	Mask_Map_X	       = (unsigned short*)(XGAAddr+0x006C);
unsigned short*	Mask_Map_Y	       = (unsigned short*)(XGAAddr+0x006E);
unsigned long *	Src_Base_Ptr       = (unsigned long*)(XGAAddr+0x0070);
/*unsigned short*	Source_Map_X       = (unsigned short*)(XGAAddr+0x0070);*/
/*unsigned short*	Source_Map_Y       = (unsigned short*)(XGAAddr+0x0072);*/
unsigned short*	Pattern_Map_X      = (unsigned short*)(XGAAddr+0x0074);
unsigned short*	Pattern_Map_Y      = (unsigned short*)(XGAAddr+0x0076);
unsigned char *	Dst_X_Phase	       = (unsigned char*)(XGAAddr+0x0078);
unsigned char *	Dst_Y_Phase	       = (unsigned char*)(XGAAddr+0x007A);
unsigned char *	Pat_Y_Phase	       = (unsigned char*)(XGAAddr+0x007A);
unsigned char *	Pat_X_Phase	       = (unsigned char*)(XGAAddr+0x0150);

unsigned char *	SLine_RoOv	       = (unsigned char*)(XGAAddr+0x0134);
unsigned char *	SLine_Incr	       = (unsigned char*)(XGAAddr+0x0135);
unsigned char *	SLine_Pttn	       = (unsigned char*)(XGAAddr+0x0136);
unsigned char *	SLine_Accu	       = (unsigned char*)(XGAAddr+0x0137);
unsigned char *	SLine_Indx	       = (unsigned char*)(XGAAddr+0x0138);

unsigned long *	Src_Start_Ptr      = (unsigned long*)(XGAAddr+0x0170);
unsigned long *	Dst_Start_Ptr      = (unsigned long*)(XGAAddr+0x0178);
 
unsigned long *	Px_Op	             = (unsigned long*)(XGAAddr+0x007C);
unsigned short*	Px_OpL	           = (unsigned short*)(XGAAddr+0x007C);
unsigned short*	Px_OpH	           = (unsigned short*)(XGAAddr+0x007C+0x2);
 
#endif /*_IGSCOP_H */

